#define _BitMapToRegion 				0xA8D7
#define _Unimplemented					0xA89F

#ifndef NIL
#define NIL ((void *)0)
#endif

/* resource numbers */
#define DLOG_ID 1
#define TEXT_ID 1
#define ALRT_ID 2

/* dialog item numbers */
#define CONT 1
#define QUIT 2
#define TEXT 9
#define SBAR 10

/* local globals */
static TEHandle Te;
static Rect Frame, TeRect;
static int Height, Page;
static ControlHandle Bar;

pascal void drawUser(wind, item)
WindowPtr wind; int item;
{	GrafPtr oldp;

	switch(item)
	{	case TEXT:
			GetPort(&oldp);
			SetPort(wind);
			
			TEUpdate(&TeRect, Te);
			FrameRect(&Frame);
			
			SetPort(oldp);
			break;
		case SBAR:
			ShowControl(Bar);
			break;
		default:
			;
	}
}

pascal void track(ch, part)
ControlHandle ch; int part;
{	register int scale, val;
	register int minV, curV, maxV;
	
	minV = GetCtlMin(ch);
	curV = GetCtlValue(ch);
	maxV = GetCtlMax(ch);

	switch(part)
	{	case inUpButton: scale = 1; break;
		case inDownButton: scale = -1; break;
		case inPageUp:
			scale = curV - minV; if(scale > Page) scale = Page; break;
		case inPageDown:
			scale = curV - maxV; if(scale < -Page) scale = -Page; break;
		default: return;
	}
	val = curV - scale;
	if(val >= minV && val <= maxV)
	{	TEScroll(0, Height * scale, Te);
		SetCtlValue(ch, val);
	}
}

int doDialog()
{	DialogPtr dp;
	Handle ig, th;
	Rect r;
	Point pt;
	int type, item, start, end, part;
	ControlHandle ch;
	GrafPtr oldp;

	/* check we have BitMapToRegion trap */
	asm
	{	move.w	#_Unimplemented,d0
		_GetTrapAddress
		move.l	a0,-(a7)
		move.w	#_BitMapToRegion,d0
		_GetTrapAddress	NEWTOOL
		cmp.l	(a7)+,a0
		bne		@gotTrap
	}
	/* here if trap is missing */
	StopAlert(ALRT_ID, NIL);
	return(0); /* fail */
	
gotTrap:
	dp = GetNewDialog(DLOG_ID, NIL, (WindowPtr)-1);
	GetDItem(dp, TEXT, &type, &ig, &TeRect);
	SetDItem(dp, TEXT, type, (Handle)drawUser, &TeRect);

	GetPort(&oldp);
	SetPort(dp);
	Frame = TeRect;
	InsetRect(&TeRect, 1, 1);
	Te = TENew(&TeRect, &TeRect);
	SetPort(oldp);

	th = GetResource('TEXT', TEXT_ID);
	HLock(th);
	TESetText(*th, GetHandleSize(th), Te);
	ReleaseResource(th);

	Height = (*Te)->lineHeight;
	Page = (TeRect.bottom - TeRect.top) / Height - 1;
	
	GetDItem(dp, SBAR, &type, &ig, &r);
	Bar = NewControl(dp, &r, "\p", false, 0, 0, (*Te)->nLines - Page, 16, 0);
	SetDItem(dp, SBAR, type, (Handle)drawUser, &r);
	
	ShowWindow(dp);
	
	while(1)
	{	ModalDialog(NIL, &item);
		switch(item)
		{	case SBAR:
				GetPort(&oldp);
				SetPort(dp);
				GetMouse(&pt);
				SetPort(oldp);
				if((part = TestControl(Bar, pt)) != 0)
				{	if(part == inThumb)
					{	start = GetCtlValue(Bar);
						TrackControl(Bar, pt, NIL);
						end = GetCtlValue(Bar);
						TEScroll(0, (start - end) * Height, Te);
					}
					else
						TrackControl(Bar, pt, track);
				}
				break;
			case QUIT:
			case CONT:
				TEDispose(Te);
				DisposDialog(dp);
				return(item == CONT);
			default:
				;
		}
	}
}
	